#include <iostream>
#include <vector>
#include "histogram.h"
#include "text.h"
#include "svg.h"
#include <string>
#include <curl/curl.h>

using namespace std;

struct Input {
    vector<double> numbers;
    size_t bin_count{};
    string stroke;
    string fill;
};

Input
input_data(istream& Newcin){
    size_t number_count;
    cerr << "Enter number count: ";
    Newcin >> number_count;
    bool prompt;
    cerr << "Do you want any prompts? Enter 'true' if yes, 'false' if no: ";
    Newcin >> prompt;
    if (prompt){
        cerr << "Prompt";
    }

    Input in;
    in.numbers.resize(number_count);
    cerr << "Enter numbers: ";
    for (size_t i = 0; i < number_count; i++) {
        Newcin >> in.numbers[i];
    }
    cerr << "Enter bin count: ";
    Newcin >> in.bin_count;
    cerr << "Enter stroke in format RGB: ";
    Newcin >> in.stroke;
    cerr << "Enter fill in format RGB: ";
    Newcin >> in.fill;
    return in;
}

int
main(int argc, char* argv[]) {
    if (argc > 1) {
        CURL *curl = curl_easy_init();
        if(curl) {
            CURLcode res;
            curl_easy_setopt(curl, CURLOPT_URL, argv[1]);
            res = curl_easy_perform(curl);
            curl_easy_cleanup(curl);
        }
        return 0;
    }
    curl_global_init(CURL_GLOBAL_ALL);
    auto in = input_data(cin);
    auto bins = make_histogram(in.numbers, in.bin_count);
    show_histogram_svg(bins, in.stroke, in.fill);
}
